package pawel;

//package security;

//import gui.In;
import sun.security.pkcs.PKCS10;
import sun.security.x509.CertAndKeyGen;
import sun.security.x509.X500Name;
import sun.security.x509.X500Signer;

import java.io.*;
import java.security.*;
import java.security.cert.Certificate;
import java.security.cert.CertificateException;
import java.security.cert.CertificateFactory;
import java.security.cert.X509Certificate;
import java.security.interfaces.DSAKey;
import java.text.MessageFormat;
import java.util.*;

//import gui.In;


public class KeyUtils2 {
    public static final ResourceBundle rb = ResourceBundle.getBundle(
            "sun.security.util.Resources");

    public static void main(String[] args) {
        makeKeyStoreFile1();
        importCertificate();
    }


    // pawel
       public static File makeKeyStoreFile1() {
        File f = getDefaultKeyStoreFile1();
  //      if (f.exists()) {
 //           In.message(
  //                  "file:" + f +
  //                  " exists, program terminates");
  //          System.exit(0);
   //     }
        try {
            KeyStore ks = KeyUtils2.generateKeyStore1();
            generateKeyPair1(ks);
            String pswd = "ewunia27";
            KeyUtils2.save1(f, ks, pswd);
            //In.message("file:" + f + " created");
            System.out.println("file:" + f + " created");
            //promptForCertReq(ks, pswd);
            writeCertReq("mykey",pswd,ks);
        } catch (Exception e) {
            System.out.println(e);
        }
        return f;
    }

        public static KeyStore generateKeyStore1()
                throws KeyStoreException,
                       IOException,
                       NoSuchAlgorithmException,
                       CertificateException {
            KeyStore ks =
                    KeyStore.getInstance(
                            KeyStore.getDefaultType());
            ks.load(null, null);
            return ks;
    }

    public static void generateKeyPair1(
                KeyStore ks)
                throws Exception {
            X500Name x500Name = getX500Name1();
            int validity = 90;
            int keysize = 1024;
            String alias = "mykey";
            String keyPass = "ewunia27";
            String sigAlgName = "MD5WithRSA";
            String keyAlgName = "RSA";
            CertAndKeyGen keypair = new CertAndKeyGen(
                    keyAlgName, sigAlgName);
            keypair.generate(keysize);
            PrivateKey privKey = keypair.getPrivateKey();
            System.out.println("privKey:" + privKey.toString() + " created");
            X509Certificate chain[] = new X509Certificate[1];
            chain[0] =
            keypair.getSelfCertificate(x500Name,
                                       validity * 24 *
                                       60 *
                                       60);
            ks.setKeyEntry(alias,
                           privKey,
                           keyPass.toCharArray(),
                           chain);
        }


        public static File getDefaultKeyStoreFile1() {
            return new File(System.getProperty(
                    "user.home") +
                            File.separatorChar +
                            "pawelkeystore");
    }

    public static X500Name getX500Name1()
	            throws IOException {
	        boolean promptP = false;
	        String commonName = "Pawel Krepsztul";
	        String organizationalUnit = "ECE";
	        String organization = "FU";
	        String city = "Fairfield";
	        String state = "CT";
	        String country = "US";
	        X500Name name;

	            name =
	            new X500Name(commonName,
	                         organizationalUnit,
	                         organization,
	                         city,
	                         state,
	                         country);

	        return name;
    }
    public static void save1(File ksFile,
                            KeyStore ks,
                            String password) {
        try {
            FileOutputStream fos = new FileOutputStream(
                    ksFile.getAbsolutePath());
            ks.store(fos,
                     password.toCharArray());
            fos.close();
        } catch (Exception e) {
            System.out.println(e);
        }
    }
     public static void writeCertReq(String alias,
	                                    String keyPass,
	                                    KeyStore ks) {
	        Object objs[] = recoverPrivateKey(ks,
	                                          alias,
	                                          keyPass.toCharArray());
	        PrivateKey privKey = (PrivateKey) objs[0];
	        if (keyPass == null)
	            keyPass =
	            new String((char[]) objs[1]);
	        PKCS10 request = null;
	        try {
	            Certificate cert = ks.getCertificate(
	                    alias);
	            request = new PKCS10(
	                    cert.getPublicKey());
	            String sigAlgName = "MD5WithRSA";
	            Signature signature = Signature.getInstance(
	                    sigAlgName);
	            signature.initSign(privKey);
	            X500Name subject = new X500Name(
	                    ((X509Certificate) cert).getSubjectDN()
	                    .toString());
	            X500Signer signer = new X500Signer(
	                    signature, subject);
	            request.encodeAndSign(signer);
	            request.print(System.out);
	            //boolean b = In.getBoolean(
	             //       "would you like to save the certificate request to a file?");
	            //if (!b) return;
	            File f = new File(System.getProperty("user.home") +
                            File.separatorChar +"client.cer");
	            FileOutputStream fos = new FileOutputStream(
	                    f);
	            PrintStream ps = new PrintStream(fos);
	            request.print(ps);
	            fos.close();
	        } catch (Exception e) {
	            System.out.println(e);
	        }
	    }

	    private static Object[] recoverPrivateKey(
	            KeyStore ks,
	            String alias,
	            char keyPass[]) {
	        Key key = null;
	        try {
	            key = ks.getKey(alias, keyPass);
	        } catch (Exception e) {
	            System.out.println(e);
	        }
	        return (new Object[]{
	            (PrivateKey) key, keyPass
	        });
    }

     public static java.security.cert.Certificate importCertificate() {

		     //String PASS ="";
             File f = getDefaultTrustKeyStoreFile();
	         try {
				 FileInputStream is = new FileInputStream(f);
				 CertificateFactory cf = CertificateFactory.getInstance("X.509");
				 Certificate cert = cf.generateCertificate(is);
				 System.out.println("Certificate type for client.cer is "+ cert.getType());
				 return cert;

	         } catch (Exception e) {
	             System.out.println(e);
	         }
	         return null;
    }

    	 public static File getDefaultTrustKeyStoreFile() {
			 return new File(System.getProperty(
					 "user.home") +
							 File.separatorChar +
							 "client.cer");
      }
    //end pawel
}
