package pawel;

import futils.Futil;

import javax.net.ssl.*;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.Serializable;
import java.io.File;
import java.net.ServerSocket;
import java.rmi.server.RMIServerSocketFactory;
import java.security.KeyStore;

/**
 * Created by IntelliJ IDEA.
 * User: pkrepszt
 * Date: Nov 16, 2004
 * Time: 7:28:13 PM
 * To change this template use File | Settings | File Templates.
 */
public class RMISSLServerSocketFactory implements RMIServerSocketFactory, Serializable {

    public ServerSocket createServerSocket(int port)
            throws IOException
    {
        SSLServerSocketFactory ssf = null;
        SSLServerSocket serverSocket = null;
        try {
            char[] passphrase = "paul27".toCharArray();

            KeyStore ks = KeyStore.getInstance("JKS");

            ks.load(new FileInputStream(getServerKeyStoreFile()), passphrase);
            KeyManagerFactory kmf = KeyManagerFactory.getInstance("SunX509");
            kmf.init(ks, passphrase);
            KeyStore ts = KeyStore.getInstance("JKS");
            ts.load(new FileInputStream(getServerTrustStoreFile()), null);
            TrustManagerFactory tmf = TrustManagerFactory.getInstance("SunX509");
            tmf.init(ts);
            SSLContext ctx = SSLContext.getInstance("TLS");
            ctx.init(kmf.getKeyManagers(), tmf.getTrustManagers(), null);
            ssf = ctx.getServerSocketFactory();
            //System.out.println((String)ssf.getDefault().toString());
            // System.out.println("server KS "+ ks.getProvider().toString());
            //System.out.println("server KMF "+ kmf.getKeyManagers().toString());
            //System.out.println("server TMF "+ tmf.getTrustManagers().toString());
            //System.out.println("server Ciphers "+ ssf.getSupportedCipherSuites().toString());
            serverSocket =(SSLServerSocket)ssf.createServerSocket(port);
            serverSocket.setNeedClientAuth(true);
        } catch (Exception e) {
            e.printStackTrace();
        } //System.out.println("server2");
        return serverSocket;
    }

    private final static File getServerKeyStoreFile() {
        File serverKeyStoreFile = new File("serverKeyStore");
        if (!serverKeyStoreFile.canRead())
            serverKeyStoreFile = Futil.getReadFile("select serverKeyStore");
        return serverKeyStoreFile;
    }

    private final static File getServerTrustStoreFile() {
        File serverTrustStoreFile = new File("serverTrustStore");
        if (!serverTrustStoreFile.canRead())
            serverTrustStoreFile =
                    Futil.getReadFile("select serverTrustStoreFile");
        return serverTrustStoreFile;
    }
}


















